diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lbaselib.c olsrd-current/lib/tas/src/lua/lbaselib.c
--- olsrd-0.5.0/lib/tas/src/lua/lbaselib.c	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lbaselib.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lbaselib.c,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: lbaselib.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Basic library
 ** See Copyright Notice in lua.h
 */
@@ -75,7 +75,7 @@
   return 1;
 }
 
-
+static int luaB_error (lua_State *L)  __attribute__((noreturn));
 static int luaB_error (lua_State *L) {
   int level = luaL_optint(L, 2, 1);
   luaL_checkany(L, 1);
@@ -86,7 +86,7 @@
     lua_pushvalue(L, 1);
     lua_concat(L, 2);
   }
-  return lua_error(L);
+  lua_error(L);
 }
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/ldebug.c olsrd-current/lib/tas/src/lua/ldebug.c
--- olsrd-0.5.0/lib/tas/src/lua/ldebug.c	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/ldebug.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: ldebug.c,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: ldebug.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Debug Interface
 ** See Copyright Notice in lua.h
 */
@@ -547,7 +547,6 @@
     luaG_runerror(L, "attempt to compare two %s values", t1);
   else
     luaG_runerror(L, "attempt to compare %s with %s", t1, t2);
-  return 0;
 }
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/ldebug.h olsrd-current/lib/tas/src/lua/ldebug.h
--- olsrd-0.5.0/lib/tas/src/lua/ldebug.h	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/ldebug.h	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: ldebug.h,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: ldebug.h,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Auxiliary functions from Debug Interface module
 ** See Copyright Notice in lua.h
 */
@@ -19,12 +19,12 @@
 
 
 void luaG_inithooks (lua_State *L);
-void luaG_typeerror (lua_State *L, const TObject *o, const char *opname);
-void luaG_concaterror (lua_State *L, StkId p1, StkId p2);
-void luaG_aritherror (lua_State *L, const TObject *p1, const TObject *p2);
-int luaG_ordererror (lua_State *L, const TObject *p1, const TObject *p2);
-void luaG_runerror (lua_State *L, const char *fmt, ...);
-void luaG_errormsg (lua_State *L);
+void luaG_typeerror (lua_State *L, const TObject *o, const char *opname) __attribute__((noreturn));
+void luaG_concaterror (lua_State *L, StkId p1, StkId p2) __attribute__((noreturn));
+void luaG_aritherror (lua_State *L, const TObject *p1, const TObject *p2) __attribute__((noreturn));
+int luaG_ordererror (lua_State *L, const TObject *p1, const TObject *p2) __attribute__((noreturn));
+void luaG_runerror (lua_State *L, const char *fmt, ...) __attribute__((noreturn));
+void luaG_errormsg (lua_State *L) __attribute__((noreturn));
 int luaG_checkcode (const Proto *pt);
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/ldo.h olsrd-current/lib/tas/src/lua/ldo.h
--- olsrd-0.5.0/lib/tas/src/lua/ldo.h	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/ldo.h	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: ldo.h,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: ldo.h,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Stack and Call structure of Lua
 ** See Copyright Notice in lua.h
 */
@@ -53,7 +53,7 @@
 void luaD_reallocstack (lua_State *L, int newsize);
 void luaD_growstack (lua_State *L, int n);
 
-void luaD_throw (lua_State *L, int errcode);
+void luaD_throw (lua_State *L, int errcode) __attribute__((noreturn));
 int luaD_rawrunprotected (lua_State *L, Pfunc f, void *ud);
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/liolib.c olsrd-current/lib/tas/src/lua/liolib.c
--- olsrd-0.5.0/lib/tas/src/lua/liolib.c	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/liolib.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: liolib.c,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: liolib.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Standard I/O (and system) library
 ** See Copyright Notice in lua.h
 */
@@ -50,6 +50,8 @@
 
 
 
+static int io_exit (lua_State *L) __attribute__((noreturn));
+
 
 /*
 ** {======================================================
@@ -555,10 +557,15 @@
 }
 
 
+#if !USE_TMPNAME
+static int io_tmpname (lua_State *L) __attribute__((noreturn));
+#else
+static int io_tmpname (lua_State *L);
+#endif
+
 static int io_tmpname (lua_State *L) {
 #if !USE_TMPNAME
   luaL_error(L, "`tmpname' not supported");
-  return 0;
 #else
   char buff[L_tmpnam];
   if (tmpnam(buff) != buff)
@@ -714,7 +721,6 @@
 
 static int io_exit (lua_State *L) {
   exit(luaL_optint(L, 1, EXIT_SUCCESS));
-  return 0;  /* to avoid warnings */
 }
 
 static const luaL_reg syslib[] = {
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/llex.c olsrd-current/lib/tas/src/lua/llex.c
--- olsrd-0.5.0/lib/tas/src/lua/llex.c	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/llex.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: llex.c,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: llex.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Lexical Analyzer
 ** See Copyright Notice in lua.h
 */
@@ -21,9 +21,10 @@
 #include "lzio.h"
 
 
-
 #define next(LS) (LS->current = zgetc(LS->z))
 
+static void luaX_error (LexState *ls, const char *s, const char *token) __attribute__((noreturn));
+static void luaX_lexerror (LexState *ls, const char *s, int token) __attribute__((noreturn));
 
 
 /* ORDER RESERVED */
@@ -58,7 +59,6 @@
   }
 }
 
-
 void luaX_errorline (LexState *ls, const char *s, const char *token, int line) {
   lua_State *L = ls->L;
   char buff[MAXSRC];
@@ -67,7 +67,6 @@
   luaD_throw(L, LUA_ERRSYNTAX);
 }
 
-
 static void luaX_error (LexState *ls, const char *s, const char *token) {
   luaX_errorline(ls, s, token, ls->linenumber);
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/llex.h olsrd-current/lib/tas/src/lua/llex.h
--- olsrd-0.5.0/lib/tas/src/lua/llex.h	2005-04-12 19:17:26.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/llex.h	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: llex.h,v 1.1 2005/04/12 17:17:26 tlopatic Exp $
+** $Id: llex.h,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Lexical Analyzer
 ** See Copyright Notice in lua.h
 */
@@ -67,8 +67,8 @@
 void luaX_setinput (lua_State *L, LexState *LS, ZIO *z, TString *source);
 int luaX_lex (LexState *LS, SemInfo *seminfo);
 void luaX_checklimit (LexState *ls, int val, int limit, const char *msg);
-void luaX_syntaxerror (LexState *ls, const char *s);
-void luaX_errorline (LexState *ls, const char *s, const char *token, int line);
+void luaX_syntaxerror (LexState *ls, const char *s) __attribute__((noreturn));
+void luaX_errorline (LexState *ls, const char *s, const char *token, int line) __attribute__((noreturn));
 const char *luaX_token2str (LexState *ls, int token);
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lparser.c olsrd-current/lib/tas/src/lua/lparser.c
--- olsrd-0.5.0/lib/tas/src/lua/lparser.c	2005-04-12 19:17:27.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lparser.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lparser.c,v 1.1 2005/04/12 17:17:27 tlopatic Exp $
+** $Id: lparser.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Lua Parser
 ** See Copyright Notice in lua.h
 */
@@ -51,6 +51,7 @@
 */
 static void chunk (LexState *ls);
 static void expr (LexState *ls, expdesc *v);
+static void error_expected (LexState *ls, int token) __attribute__((noreturn));
 
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lua.h olsrd-current/lib/tas/src/lua/lua.h
--- olsrd-0.5.0/lib/tas/src/lua/lua.h	2005-04-12 19:17:27.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lua.h	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lua.h,v 1.1 2005/04/12 17:17:27 tlopatic Exp $
+** $Id: lua.h,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** Lua - An Extensible Extension Language
 ** Tecgraf: Computer Graphics Technology Group, PUC-Rio, Brazil
 ** http://www.lua.org	mailto:info@lua.org
@@ -213,7 +213,7 @@
 
 LUA_API const char *lua_version (void);
 
-LUA_API int   lua_error (lua_State *L);
+LUA_API int   lua_error (lua_State *L) __attribute__((noreturn));
 
 LUA_API int   lua_next (lua_State *L, int idx);
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/lua/lundump.c olsrd-current/lib/tas/src/lua/lundump.c
--- olsrd-0.5.0/lib/tas/src/lua/lundump.c	2005-04-12 19:17:35.000000000 +0200
+++ olsrd-current/lib/tas/src/lua/lundump.c	2007-04-20 15:46:03.000000000 +0200
@@ -1,5 +1,5 @@
 /*
-** $Id: lundump.c,v 1.1 2005/04/12 17:17:35 tlopatic Exp $
+** $Id: lundump.c,v 1.2 2007/04/20 13:46:03 bernd67 Exp $
 ** load pre-compiled Lua chunks
 ** See Copyright Notice in lua.h
 */
@@ -26,6 +26,8 @@
  const char* name;
 } LoadState;
 
+static void unexpectedEOZ (LoadState* S) __attribute__((noreturn));
+
 static void unexpectedEOZ (LoadState* S)
 {
  luaG_runerror(S->L,"unexpected end of file in %s",S->name);
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/os_unix.c olsrd-current/lib/tas/src/os_unix.c
--- olsrd-0.5.0/lib/tas/src/os_unix.c	2005-11-16 00:46:20.000000000 +0100
+++ olsrd-current/lib/tas/src/os_unix.c	2007-04-20 01:01:32.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: os_unix.c,v 1.5 2005/11/15 23:46:20 tlopatic Exp $
+ * $Id: os_unix.c,v 1.6 2007/04/19 23:01:32 bernd67 Exp $
  */
 
 #if defined linux
@@ -107,7 +107,7 @@
 
 void os_now(struct timeStamp *timeStamp)
 {
-  time((time_t *)&timeStamp->time);
+  timeStamp->time = time(NULL);
 }
 
 int timedOut(struct timeStamp *timeStamp, int sec)
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/tas/src/plugin.c olsrd-current/lib/tas/src/plugin.c
--- olsrd-0.5.0/lib/tas/src/plugin.c	2006-01-07 09:17:45.000000000 +0100
+++ olsrd-current/lib/tas/src/plugin.c	2007-04-20 15:46:03.000000000 +0200
@@ -37,7 +37,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: plugin.c,v 1.7 2006/01/07 08:17:45 kattemat Exp $
+ * $Id: plugin.c,v 1.8 2007/04/20 13:46:03 bernd67 Exp $
  */
 
 #include <string.h>
@@ -465,7 +465,7 @@
   return 4;
 }
 
-int olsrd_plugin_init()
+int olsrd_plugin_init(void)
 {
   ipAddrLen = olsr_cnf->ipsize;
   mainAddr = &olsr_cnf->main_addr;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/txtinfo/src/olsrd_plugin.c olsrd-current/lib/txtinfo/src/olsrd_plugin.c
--- olsrd-0.5.0/lib/txtinfo/src/olsrd_plugin.c	2007-01-31 13:38:26.000000000 +0100
+++ olsrd-current/lib/txtinfo/src/olsrd_plugin.c	2007-04-20 15:46:04.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_plugin.c,v 1.1 2007/01/31 12:38:26 bernd67 Exp $
+ * $Id: olsrd_plugin.c,v 1.2 2007/04/20 13:46:04 bernd67 Exp $
  */
 
 /*
@@ -78,7 +78,7 @@
  *Constructor
  */
 static void
-my_init()
+my_init(void)
 {
   /* Print plugin info to stdout */
   printf("%s\n", MOD_DESC);
@@ -96,7 +96,7 @@
  *Destructor
  */
 static void
-my_fini()
+my_fini(void)
 {
   /* Calls the destruction function
    * olsr_plugin_exit()
@@ -109,7 +109,7 @@
 
 
 int 
-olsrd_plugin_interface_version()
+olsrd_plugin_interface_version(void)
 {
   return PLUGIN_INTERFACE_VERSION;
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/txtinfo/src/olsrd_txtinfo.c olsrd-current/lib/txtinfo/src/olsrd_txtinfo.c
--- olsrd-0.5.0/lib/txtinfo/src/olsrd_txtinfo.c	2007-03-27 05:59:27.000000000 +0200
+++ olsrd-current/lib/txtinfo/src/olsrd_txtinfo.c	2007-05-09 19:29:53.000000000 +0200
@@ -40,7 +40,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: olsrd_txtinfo.c,v 1.2 2007/03/27 03:59:27 tlopatic Exp $
+ * $Id: olsrd_txtinfo.c,v 1.6 2007/05/09 17:29:53 bernd67 Exp $
  */
 
 /*
@@ -101,21 +101,24 @@
 static void
 ipc_action(int);
 
-static void inline
+static void
 ipc_print_neigh_link(void);
 
-static void inline
+static void
 ipc_print_routes(void);
 
-static void inline
+static void
 ipc_print_topology(void);
 
-static void inline
+static void
 ipc_print_hna(void);
 
+static void
+ipc_print_mid(void);
+
 #define TXT_IPC_BUFSIZE 256
 static int 
-ipc_sendf(const char* format, ...);
+ipc_sendf(const char* format, ...) __attribute__((format(printf, 1, 2)));
 
 /**
  *Do initialization here
@@ -124,7 +127,7 @@
  *function in uolsrd_plugin.c
  */
 int
-olsrd_plugin_init()
+olsrd_plugin_init(void)
 {
   /* Initial IPC value */
   ipc_open = 0;
@@ -139,7 +142,7 @@
  * destructor - called at unload
  */
 void
-olsr_plugin_exit()
+olsr_plugin_exit(void)
 {
   if(ipc_open)
     close(ipc_socket);
@@ -148,7 +151,7 @@
 
 
 static int
-plugin_ipc_init()
+plugin_ipc_init(void)
 {
   struct sockaddr_in sin;
   olsr_u32_t yes = 1;
@@ -239,6 +242,10 @@
     }
   else
     {
+      fd_set rfds;
+      struct timeval tv = {0,0};
+      int neighonly = 0;
+
       addr = inet_ntoa(pin.sin_addr);
       if(ntohl(pin.sin_addr.s_addr) != ntohl(ipc_accept_ip.s_addr))
 	{
@@ -254,14 +261,11 @@
 #endif
       
       /* purge read buffer to prevent blocking on linux*/
-      fd_set rfds;
       FD_ZERO(&rfds);
-      FD_SET(ipc_connection, &rfds);
-      struct timeval tv = {0,0};
-      int neighonly = 0;
+      FD_SET((unsigned int)ipc_connection, &rfds); /* Win32 needs the cast here */
       if(select(ipc_connection+1, &rfds, NULL, NULL, &tv)) {
         char requ[128];
-        ssize_t s = recv(ipc_connection, &requ, sizeof(requ), 0);
+        ssize_t s = recv(ipc_connection, (void*)&requ, sizeof(requ), 0); /* Win32 needs the cast here */
         if (0 < s) {
           requ[s] = 0;
           /* To print out neighbours only on the Freifunk Status
@@ -280,7 +284,7 @@
   }
 }
 
-static void inline
+static void
 ipc_print_neigh_link(void)
 {
   struct neighbor_entry *neigh;
@@ -339,7 +343,7 @@
 }
 
 
-static void inline
+static void
 ipc_print_routes(void)
 {
   int size = 0, index;
@@ -383,7 +387,7 @@
 
 }
 
-static void inline
+static void
 ipc_print_topology(void)
 {
   olsr_u8_t index;
@@ -420,20 +424,21 @@
   ipc_sendf("\n");
 }
 
-static void inline
+static void
 ipc_print_hna(void)
 {
   int size;
   olsr_u8_t index;
   struct hna_entry *tmp_hna;
   struct hna_net *tmp_net;
+  struct hna4_entry *hna4;
+  struct hna6_entry *hna6;
 
   size = 0;
 
   ipc_sendf("Table: HNA\nNetwork\tNetmask\tGateway\n");
 
   /* Announced HNA entries */
-	struct hna4_entry *hna4;
 	for(hna4 = olsr_cnf->hna4_entries; hna4; hna4 = hna4->next)
 	  {
 			ipc_sendf("%s\t%s\t%s\n",
@@ -441,7 +446,6 @@
 			  olsr_ip_to_string(&hna4->netmask),
 				olsr_ip_to_string(&olsr_cnf->main_addr));
 	  }
-	struct hna6_entry *hna6;
 	for(hna6 = olsr_cnf->hna6_entries; hna6; hna6 = hna6->next)
 	  {
 			ipc_sendf("%s\t%d\t%s\n",
@@ -485,6 +489,46 @@
 
 }
 
+static void
+ipc_print_mid(void)
+{
+    olsr_u8_t index;
+    unsigned short is_first;
+    struct mid_entry *entry;
+    struct mid_address *alias;
+
+    ipc_sendf("Table: MID\nIP\tAliases\n");
+
+    /* MID */
+    for( index = 0; index < HASHSIZE; index++ )
+    {
+        entry = mid_set[index].next;
+
+        while( entry != &mid_set[index] )
+        {
+            ipc_sendf( olsr_ip_to_string( &entry->main_addr ) );
+            alias = entry->aliases;
+            is_first = 1;
+
+            while( alias )
+            {
+                ipc_sendf( "%s%s",
+                    ( is_first ? "\t" : ";" ),
+                    olsr_ip_to_string( &alias->alias )
+                );
+
+                alias = alias->next_alias;
+                is_first = 0;
+            }
+
+            entry = entry->next;
+            ipc_sendf("\n");
+        }
+    }
+
+	ipc_sendf("\n");
+}
+
 
 static void 
 send_info(int neighonly)
@@ -505,6 +549,9 @@
  	/* hna */
 	if (!neighonly) ipc_print_hna();
 
+ 	/* mid */
+	if (!neighonly) ipc_print_mid();
+
 	/* routes */
 	if (!neighonly) ipc_print_routes();
 }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/make/guess_os.sh olsrd-current/make/guess_os.sh
--- olsrd-0.5.0/make/guess_os.sh	2005-12-29 20:48:43.000000000 +0100
+++ olsrd-current/make/guess_os.sh	2007-05-14 01:44:24.000000000 +0200
@@ -1,11 +1,6 @@
 #!/bin/sh
 
 if test -n "$OS"; then
-	# cygwin exports the OS environment vaiable - fix it. 
-	# otherwiese accept the user supplied OS
-	case "$OS" in
-		Windows*)	OS=win32 ;;
-	esac
 	echo $OS;
 	exit;
 else
@@ -17,7 +12,7 @@
 		freebsd*)	arch=fbsd ;;
 		netbsd*)	arch=nbsd ;;
 		openbsd*)	arch=obsd ;;
-		darwin*)		arch=osx ;;
+		darwin*)	arch=osx ;;
 		cygwin_*)	arch=win32 ;;
 		Windows_*)	arch=win32 ;;
 		*)		arch="UNKNOWN" ;;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/make/Makefile.linux olsrd-current/make/Makefile.linux
--- olsrd-0.5.0/make/Makefile.linux	2007-02-10 20:59:51.000000000 +0100
+++ olsrd-current/make/Makefile.linux	2007-04-27 13:41:25.000000000 +0200
@@ -22,6 +22,9 @@
 ifeq ($(ARCH),x86_64)
 GENERATE_PIC = true
 endif
+ifeq ($(ARCH),alpha)
+GENERATE_PIC = true
+endif
 
 ifdef GENERATE_PIC
 CFLAGS +=	-fPIC
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/Makefile olsrd-current/Makefile
--- olsrd-0.5.0/Makefile	2007-04-02 12:02:35.000000000 +0200
+++ olsrd-current/Makefile	2007-05-01 23:36:50.000000000 +0200
@@ -35,15 +35,17 @@
 # to the project. For more information see the website or contact
 # the copyright holders.
 #
-# $Id: Makefile,v 1.78 2007/04/02 09:40:48 tlopatic Exp $
+# $Id: Makefile,v 1.84 2007/05/01 21:36:50 bernd67 Exp $
 
-VERS =		0.5.0
-
-CFLAGS +=	-DVERSION=\"$(VERS)\"
+VERS =		0.5.1pre
 
 TOPDIR = .
 include Makefile.inc
 
+CFLAGS +=	-DVERSION=\"$(VERS)\"
+
+MAKECMD = $(MAKE) OS="$(OS)" WARNINGS="$(WARNINGS)"
+
 LIBS +=		$(OS_LIB_DYNLOAD)
 
 ifeq ($(OS), win32)
@@ -62,27 +64,26 @@
 		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(CFGOBJS) $(LIBS)
 
 cfgparser:	$(CFGDEPS)
-		$(MAKE) -C $(CFGDIR)
+		$(MAKECMD) -C $(CFGDIR)
 
 switch:		
-		$(MAKE) -C $(SWITCHDIR)
+		$(MAKECMD) -C $(SWITCHDIR)
 
 $(CFGOBJS):
-		$(MAKE) -C $(CFGDIR)
+		$(MAKECMD) -C $(CFGDIR)
 
 .PHONY: help libs clean_libs libs_clean clean uberclean install_libs libs_install install_bin install_olsrd install build_all install_all clean_all
 
 clean:
 		-rm -f $(OBJS) $(SRCS:%.c=%.d) olsrd olsrd.exe
-		$(MAKE) -C $(CFGDIR) clean
-		$(MAKE) -C $(SWITCHDIR) clean
+		$(MAKECMD) -C $(CFGDIR) clean
+		$(MAKECMD) -C $(SWITCHDIR) clean
 
 uberclean:	clean clean_libs
 		-rm -f $(TAGFILE)
-		-rm -f src/*.[od~] 
-		-rm -f src/linux/*.[od~] src/unix/*.[od~] src/win32/*.[od~] src/bsd/*.[od~]
-		$(MAKE) -C $(CFGDIR) uberclean
-		$(MAKE) -C $(SWITCHDIR) clean
+		find . \( -name '*.[od]' -o -name '*~' \) -print | xargs -r rm -f
+		$(MAKECMD) -C $(CFGDIR) uberclean
+		$(MAKECMD) -C $(SWITCHDIR) clean
 
 install: install_olsrd
 
@@ -123,60 +124,60 @@
 #
 
 libs: 
-		$(MAKE) -C lib LIBDIR=$(LIBDIR)
+		$(MAKECMD) -C lib LIBDIR=$(LIBDIR)
 
 libs_clean clean_libs:
-		$(MAKE) -C lib LIBDIR=$(LIBDIR) clean
+		$(MAKECMD) -C lib LIBDIR=$(LIBDIR) clean
 
 libs_install install_libs:
-		$(MAKE) -C lib LIBDIR=$(LIBDIR) install
+		$(MAKECMD) -C lib LIBDIR=$(LIBDIR) install
 
 httpinfo:
-		$(MAKE) -C lib/httpinfo clean
-		$(MAKE) -C lib/httpinfo 
-		$(MAKE) -C lib/httpinfo DESTDIR=$(DESTDIR) install 
+		$(MAKECMD) -C lib/httpinfo clean
+		$(MAKECMD) -C lib/httpinfo 
+		$(MAKECMD) -C lib/httpinfo DESTDIR=$(DESTDIR) install 
 
 tas:
-		$(MAKE) -C lib/tas clean
-		$(MAKE) -C lib/tas DESTDIR=$(DESTDIR) install
+		$(MAKECMD) -C lib/tas clean
+		$(MAKECMD) -C lib/tas DESTDIR=$(DESTDIR) install
 
 dot_draw:
-		$(MAKE) -C lib/dot_draw clean
-		$(MAKE) -C lib/dot_draw DESTDIR=$(DESTDIR) install
+		$(MAKECMD) -C lib/dot_draw clean
+		$(MAKECMD) -C lib/dot_draw DESTDIR=$(DESTDIR) install
 
 nameservice:
-		$(MAKE) -C lib/nameservice clean
-		$(MAKE) -C lib/nameservice DESTDIR=$(DESTDIR) install
+		$(MAKECMD) -C lib/nameservice clean
+		$(MAKECMD) -C lib/nameservice DESTDIR=$(DESTDIR) install
 
 dyn_gw:
-		$(MAKE) -C lib/dyn_gw clean
-		$(MAKE) -C lib/dyn_gw
-		$(MAKE) -C lib/dyn_gw DESTDIR=$(DESTDIR) install
+		$(MAKECMD) -C lib/dyn_gw clean
+		$(MAKECMD) -C lib/dyn_gw
+		$(MAKECMD) -C lib/dyn_gw DESTDIR=$(DESTDIR) install
 
 dyn_gw_plain:
-		$(MAKE) -C lib/dyn_gw_plain clean
-		$(MAKE) -C lib/dyn_gw_plain
-		$(MAKE) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) install
+		$(MAKECMD) -C lib/dyn_gw_plain clean
+		$(MAKECMD) -C lib/dyn_gw_plain
+		$(MAKECMD) -C lib/dyn_gw_plain DESTDIR=$(DESTDIR) install
 
 secure:
-		$(MAKE) -C lib/secure clean
-		$(MAKE) -C lib/secure
-		$(MAKE) -C lib/secure DESTDIR=$(DESTDIR) install
+		$(MAKECMD) -C lib/secure clean
+		$(MAKECMD) -C lib/secure
+		$(MAKECMD) -C lib/secure DESTDIR=$(DESTDIR) install
 
 pgraph:
-		$(MAKE) -C lib/pgraph clean
-		$(MAKE) -C lib/pgraph 
-		$(MAKE) -C lib/pgraph DESTDIR=$(DESTDIR) install 
+		$(MAKECMD) -C lib/pgraph clean
+		$(MAKECMD) -C lib/pgraph 
+		$(MAKECMD) -C lib/pgraph DESTDIR=$(DESTDIR) install 
 
 bmf:
-		$(MAKE) -C lib/bmf clean
-		$(MAKE) -C lib/bmf 
-		$(MAKE) -C lib/bmf DESTDIR=$(DESTDIR) install 
+		$(MAKECMD) -C lib/bmf clean
+		$(MAKECMD) -C lib/bmf 
+		$(MAKECMD) -C lib/bmf DESTDIR=$(DESTDIR) install 
 
 quagga:
-		$(MAKE) -C lib/quagga clean
-		$(MAKE) -C lib/quagga 
-		$(MAKE) -C lib/quagga DESTDIR=$(DESTDIR) install 
+		$(MAKECMD) -C lib/quagga clean
+		$(MAKECMD) -C lib/quagga 
+		$(MAKECMD) -C lib/quagga DESTDIR=$(DESTDIR) install 
 
 
 build_all:	cfgparser olsrd libs
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/Makefile.inc olsrd-current/Makefile.inc
--- olsrd-0.5.0/Makefile.inc	2007-02-05 22:25:49.000000000 +0100
+++ olsrd-current/Makefile.inc	2007-05-14 01:44:23.000000000 +0200
@@ -1,6 +1,10 @@
 # programs
-CCACHE =        $(shell sh -c "type -path ccache")
+CCACHE ?=       $(shell sh -c "type -path ccache")
+ifeq ($(origin CC),default)
+CC = 		$(CCACHE) gcc
+else
 CC ?= 		$(CCACHE) gcc
+endif
 STRIP ?=	strip
 BISON ?=	bison
 FLEX ?=		flex
@@ -20,9 +24,31 @@
 
 # add gcc warnings and optimizations if CFLAGS not set
 ifndef CFLAGS
-CFLAGS +=	-Wall -Wmissing-prototypes -Wstrict-prototypes \
-		-Wmissing-declarations -Wsign-compare
-CFLAGS +=	-O2 -g
+ifndef WARNINGS
+WARNINGS +=	-Wall
+WARNINGS +=	-Wextra
+WARNINGS +=	-Wold-style-definition
+WARNINGS +=	-Wdeclaration-after-statement
+WARNINGS +=	-Wmissing-prototypes
+WARNINGS +=	-Wstrict-prototypes
+WARNINGS +=	-Wmissing-declarations
+WARNINGS +=	-Wsign-compare
+WARNINGS +=	-Waggregate-return
+WARNINGS +=	-Wmissing-noreturn
+WARNINGS +=	-Wmissing-format-attribute
+WARNINGS +=	-Wno-multichar
+WARNINGS +=	-Wno-deprecated-declarations
+#WARNINGS +=	-Wredundant-decls
+WARNINGS +=	-Wnested-externs
+#WARNINGS +=	-Wunreachable-code
+WARNINGS +=	-Winline
+WARNINGS +=	-Wdisabled-optimization
+#WARNINGS +=	-Werror
+WARNINGS :=	$(shell CC="$(CC)" $(TOPDIR)/gcc-warnings $(WARNINGS))
+endif
+CFLAGS +=	$(WARNINGS)
+CFLAGS +=	-O2
+CFLAGS +=	-g
 endif
 
 ifdef OLSRD_PLUGIN
@@ -44,7 +70,12 @@
 all: default_target
 
 # OS detection
-OS =		$(shell sh $(TOPDIR)/make/guess_os.sh)
+ifeq ($(OS),Windows_NT)
+OS = win32
+endif
+ifeq ($(OS),)
+OS :=		$(shell sh $(TOPDIR)/make/guess_os.sh)
+endif
 ifeq ($(OS),UNKNOWN)
 all: help
 else
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/README olsrd-current/README
--- olsrd-0.5.0/README	2007-02-05 22:49:43.000000000 +0100
+++ olsrd-current/README	2007-04-03 10:46:44.000000000 +0200
@@ -1,6 +1,6 @@
 
 +====================================================================+
-| README - olsr.org OLSR daemon 0.4.10, 23.11.05                     |
+| README - olsr.org OLSR daemon 0.5.0, 02.04.2007                    |
 +====================================================================+
 
 Andreas Tonnesen(andreto@olsr.org)
@@ -135,11 +135,6 @@
     shared key can participate in the routing.
     You need to have the OpenSSL libs installed to use this plugin.
 
-  - Power plugin. A plugin that uses OLSRs MPR flooding to spread information
-    about the power status of nodes. Meant as an example plugin for code
-    reference only.
-
-
 ========================
  * LINK QUALITY ROUTING
 ========================
@@ -153,11 +148,17 @@
  * KNOWN PROBLEMS
 ==================
 
+There is no synchronization concept (and thus - and for Gods sake -  no
+code). Some plugins use threads for concurrency so this should be solved.
 
 ===============
  * FUTURE WORK
 ===============
 
+Future work concentrates on reduction of ressource (ab)use nad to make
+it more scalable. Of course additional useful plugins are always
+appreciated.
+
 Future releases of the 0.4 series will be maintainance releases focused
 on bugfixing. Work will soon begin on a 0.5 series where we will focus
 much more on new ideas. 0.4 and 0.5 might coexist for some time. 
@@ -202,14 +203,18 @@
 olsr_switch	+/+	+/+	+/+	+/+	+/+	?
 ------------------------------------------------------------
 PLUGINS
+bmf		+/+	+/?	+/+	+/+	+/+	?
 dot_draw	+/+	+/?	+/+	+/+	+/+	?
 dyn_gw		+/+	+/?	+/-	+/-	+/-	?
+dyn_gw_plain	+/+	+/?	+/-	+/-	+/-	?
 httpinfo	+/+	+/+	+/+	+/+	+/+	?
 mini		+/+	+/?	+/+	+/+	+/+	?
 nameservice	+/+	+/?	+/+	+/+	+/+	?
-powerinfo	+/+	+/+	+/-	+/-	+/-	?
+pgraph		+/+	+/+	+/+	+/+	+/+	?
+quagga		+/+	-/-	+/+	+/+	+/+	?
 secure		+/+	+/+	+/+	+/+	+/+	?
 tas		+/+	-	-	-	-	?
+txtinfo		+/+	+/+	+/+	+/+	+/+	?
 ------------------------------------------------------------
 
 LEGEND:   +/+ = compiles/runs
@@ -439,4 +444,4 @@
 installing works in the same was as on FreeBSD.
 
 
-$Id: README,v 1.17 2007/02/05 21:49:43 bernd67 Exp $
+$Id: README,v 1.18 2007/04/03 08:46:44 bernd67 Exp $
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/bsd/kernel_routes.c olsrd-current/src/bsd/kernel_routes.c
--- olsrd-0.5.0/src/bsd/kernel_routes.c	2007-02-14 10:09:16.000000000 +0100
+++ olsrd-current/src/bsd/kernel_routes.c	2007-05-02 09:41:20.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: kernel_routes.c,v 1.9 2007/02/14 09:09:16 kattemat Exp $
+ * $Id: kernel_routes.c,v 1.11 2007/05/02 07:41:20 bernd67 Exp $
  */
 
 
@@ -68,7 +68,7 @@
   inet_ntop(AF_INET, &dest->rt_router.v4, Str3, 16);
 
   OLSR_PRINTF(1, "%s IPv4 route to %s/%s via %s.\n",
-    (add != 0) ? "Adding" : "Removing", Str1, Str2, Str3)
+    (add != 0) ? "Adding" : "Removing", Str1, Str2, Str3);
 
   memset(buff, 0, sizeof (buff));
   memset(&sin, 0, sizeof (sin));
@@ -184,8 +184,8 @@
   inet_ntop(AF_INET6, &dest->rt_dst.v6, Str1, 40);
   inet_ntop(AF_INET6, &dest->rt_router.v6, Str2, 40);
 
-  OLSR_PRINTF(1, "%s IPv6 route to %s/%d via %s.\n",
-    (add != 0) ? "Adding" : "Removing", Str1, dest->rt_mask.v6, Str2)
+  OLSR_PRINTF(1, "%s IPv6 route to %s/%d via %s.\n", 
+    (add != 0) ? "Adding" : "Removing", Str1, dest->rt_mask.v6, Str2);
 
   memset(buff, 0, sizeof (buff));
   memset(&sin6, 0, sizeof (sin6));
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/bsd/net.c olsrd-current/src/bsd/net.c
--- olsrd-0.5.0/src/bsd/net.c	2007-03-14 15:01:13.000000000 +0100
+++ olsrd-current/src/bsd/net.c	2007-05-02 09:41:20.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net.c,v 1.32 2007/03/14 14:01:13 bernd67 Exp $
+ * $Id: net.c,v 1.36 2007/05/02 07:41:20 bernd67 Exp $
  */
 
 #include "defs.h"
@@ -58,6 +58,9 @@
 #include <netinet/ip_icmp.h>
 #include <netinet/icmp_var.h>
 #include <netinet/icmp6.h>
+#include <netinet6/in6_var.h> /* For struct in6_ifreq */
+#include <ifaddrs.h>
+#include <sys/uio.h>
 #endif
 
 #ifdef __FreeBSD__
@@ -97,7 +100,7 @@
 static int set_sysctl_int(char *name, int new)
 {
   int old;
-#if __MacOSX__
+#if __MacOSX__ || __OpenBSD__
   size_t len = sizeof (old);
 #else
   unsigned int len = sizeof (old);
@@ -486,7 +489,7 @@
   COPY_IP(&mcastreq.ipv6mr_multiaddr, &ifs->int6_multaddr.sin6_addr);
   mcastreq.ipv6mr_interface = ifs->if_index;
 
-  OLSR_PRINTF(3, "Interface %s joining multicast %s...",	ifs->int_name, olsr_ip_to_string((union olsr_ip_addr *)&ifs->int6_multaddr.sin6_addr))
+  OLSR_PRINTF(3, "Interface %s joining multicast %s...",	ifs->int_name, olsr_ip_to_string((union olsr_ip_addr *)&ifs->int6_multaddr.sin6_addr));
 
   /* rfc 3493 */
 #ifdef IPV6_JOIN_GROUP
@@ -524,7 +527,7 @@
     }
 
 
-  OLSR_PRINTF(3, "OK\n")
+  OLSR_PRINTF(3, "OK\n");
   return 0;
 }
 
@@ -542,7 +545,7 @@
 
   if (getifaddrs(&ifap) != 0)
     {
-      OLSR_PRINTF(3, "get_ipv6_address: getifaddrs() failed.\n")
+      OLSR_PRINTF(3, "get_ipv6_address: getifaddrs() failed.\n");
       return 0;
     }
 
@@ -639,7 +642,7 @@
   context = libnet_init(LIBNET_LINK, iface->int_name, errbuf);
   if (context == NULL)
     {
-      OLSR_PRINTF (1, "libnet init: %s\n", libnet_geterror (context))
+      OLSR_PRINTF (1, "libnet init: %s\n", libnet_geterror (context));
       return (0);
     }
 
@@ -659,7 +662,7 @@
 			      udp_tag);				/* pblock */
   if (udp_tag == -1)
     {
-      OLSR_PRINTF (1, "libnet UDP header: %s\n", libnet_geterror (context))
+      OLSR_PRINTF (1, "libnet UDP header: %s\n", libnet_geterror (context));
 	return (0);
     }
 
@@ -678,7 +681,7 @@
 			      ip_tag);				/* pblock */
   if (ip_tag == -1)
     {
-      OLSR_PRINTF (1, "libnet IP header: %s\n", libnet_geterror (context))
+      OLSR_PRINTF (1, "libnet IP header: %s\n", libnet_geterror (context));
       return (0);
     }
 
@@ -691,14 +694,14 @@
 				     ether_tag);  		/* pblock tag */
   if (ether_tag == -1)
     {
-      OLSR_PRINTF (1, "libnet ethernet header: %s\n", libnet_geterror (context))
+      OLSR_PRINTF (1, "libnet ethernet header: %s\n", libnet_geterror (context));
       return (0);
     }
  
   status = libnet_write (context);
   if (status == -1)
     {
-      OLSR_PRINTF (1, "libnet packet write: %s\n", libnet_geterror (context))
+      OLSR_PRINTF (1, "libnet packet write: %s\n", libnet_geterror (context));
       return (0);
     }
 
@@ -863,11 +866,11 @@
 
       if(ioctl(olsr_cnf->ioctl_s, SIOCGIFMEDIA, &ifm) < 0)
 	{
-	  OLSR_PRINTF(1, "Error SIOCGIFMEDIA(%s)\n", ifm.ifm_name)
+	  OLSR_PRINTF(1, "Error SIOCGIFMEDIA(%s)\n", ifm.ifm_name);
 	  return WEIGHT_ETHERNET_DEFAULT;
 	}
 
-      OLSR_PRINTF(1, "%s: STATUS 0x%08x\n", ifm.ifm_name, ifm.ifm_status)
+      OLSR_PRINTF(1, "%s: STATUS 0x%08x\n", ifm.ifm_name, ifm.ifm_status);
 #endif
       return WEIGHT_ETHERNET_DEFAULT;
     }
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/src/bsd/net.h olsrd-current/src/bsd/net.h
--- olsrd-0.5.0/src/bsd/net.h	2004-11-21 11:50:52.000000000 +0100
+++ olsrd-current/src/bsd/net.h	2007-04-20 15:46:05.000000000 +0200
@@ -36,7 +36,7 @@
  * to the project. For more information see the website or contact
  * the copyright holders.
  *
- * $Id: net.h,v 1.3 2004/11/21 10:50:52 kattemat Exp $
+ * $Id: net.h,v 1.4 2007/04/20 13:46:05 bernd67 Exp $
  */
 
 
@@ -55,7 +55,4 @@
 #include <netinet/in.h>
 #include "../olsr_protocol.h"
 
-extern int
-olsr_printf(int, char *, ...);
-
 #endif
